<template lang="pug">
  button(
    class="button-root"
    :class="classes"
    :disabled="disabled"
    :data-bold="bold"
    :data-type="type"
    :data-size="size"
    @click="onClick"
  )
    slot
</template>

<script>
export default {
  name: 'Button',
  props: {
    classes: {
      type: Array,
      default: () => []
    },
    disabled: {
      type: Boolean,
      default: false
    },
    type: String,
    size: String,
    bold: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    onClick() {
      this.$emit('click', this.value)
    }
  }
}
</script>

<style lang="stylus" scoped>
.button-root
  font-size: $fz-base
  // display: inline-block
  display flex
  justify-content: center;
  line-height: 1
  white-space: nowrap
  cursor: pointer
  background: $c-white
  color: $c-base
  -webkit-appearance: none
  text-align: center
  box-sizing: border-box
  outline: none
  -moz-user-select: none
  -webkit-user-select: none
  -ms-user-select: none
  padding: 4px 16px
  height: 60px
  width 100%
  max-width 280px
  border-radius: 30px
  font-size: $fz-base
  &:disabled
    pointer-events: none
    cursor: not-allowed
  // bold
  &[data-bold]
    font-weight: bold
  // inline button
  &[data-type="text"]
    border: none
    padding: 0
    height: auto
    color: $c-linktext
  // color
  &[data-type="primary"]
    border: none
    color: $c-text-regular
    background-color: $c-white
    &:disabled
      background-color: $c-primary-dis
      border-color: $c-primary-dis
  &[data-type="secondry"]
    color: $c-base
    background-color: alpha($c-bg, 0,2)
    border-color: $c-base
    &:disabled
      color: $c-base-dis
      background-color: alpha($c-bg, 0,1)
      border-color: $c-base-dis
  &[data-type="plane"]
    color $c-base
    background: transparent
    border none
  // size
  &[data-size="small"]
    font-size: $fz-base_small
    height: 40px
    padding: 4px 8px
    max-width 180px
  &[data-size="mini"]
    font-size: $fz-ex_small
    height: auto
    padding: 2px 4px
  &:active
    opacity: 0.9
</style>